from gi.repository import Gtk
from handler import *
import urllib
import json

class Configer(Gtk.Window):
	def __init__(self):
		super(Configer, self).__init__()
		self.handler = Handler()
		self.set_modal(True)
		self.set_title('Settings')
		self.set_resizable(False)
		#self.set_default_size(400,300)
		self.set_position(Gtk.WindowPosition.CENTER_ALWAYS)
		self.options = self.GetOptions()
		self.connect('destroy', self.destroy_window)
		
	def SetLayout(self):
		mainbox = Gtk.Box()
		mainbox.set_orientation(Gtk.Orientation.VERTICAL)
		notebook = Gtk.Notebook()
		##Tab 1
		tab1label = Gtk.Label('City')
		table = Gtk.Table()
		table.resize(3, 2)
		#City name
		defaultcity = self.options['city']
		citylabel = Gtk.Label('Choose Your City')
		self.cityentry = Gtk.Entry()
		self.cityentry.set_text('%s' % defaultcity)
		self.fetchbtn = Gtk.Button("Get Coordinates")
		self.fetchbtn.connect('clicked', self.on_click_fetch)
		table.attach(citylabel, 0, 1, 0, 1, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		table.attach(self.cityentry, 1, 2, 0, 1, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		table.attach(self.fetchbtn, 2, 3, 0, 1, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		#Latitude
		hbox1 = Gtk.Box()
		defaultlatitude = self.options['city_lat']
		latlabel = Gtk.Label('Latitude')
		self.latentry = Gtk.Entry()
		self.latentry.set_text('%f' % defaultlatitude)
		table.attach(latlabel, 0, 1, 1, 2, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		table.attach(self.latentry, 1, 2, 1, 2, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		#Longitude
		hbox2 = Gtk.Box()
		defaultlong = self.options['city_lon']
		longlabel = Gtk.Label("Longitude")
		self.longentry = Gtk.Entry()
		self.longentry.set_text('%f' % defaultlong)
		table.attach(longlabel, 0, 1, 2, 3, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		table.attach(self.longentry, 1, 2, 2, 3, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		tab1child = table
		##Tab2
		tab2label = Gtk.Label('Other')
		table = Gtk.Table()
		#Cal Method
		hbox3 = Gtk.Box()
		defaultmethod = self.options['cal_method_name']
		methods = self.handler.GetCalMethods()
		calmethodlabel = Gtk.Label('Choose Calender Method')
		self.methodsmenu = Gtk.ComboBoxText()
		for method in methods:
			self.methodsmenu.append(method, method)
		self.methodsmenu.set_active(methods.index(defaultmethod))
		table.attach(calmethodlabel, 0, 1, 0, 1, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		table.attach(self.methodsmenu, 1, 2, 0, 1, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		#Mazhab
		hbox4 = Gtk.Box()
		defaultmazhab = self.options['mazhab_name']
		mazhablabel = Gtk.Label('Choose Mazhab')
		mazaheb = self.handler.GetMazaheb()
		self.mazahebmenu = Gtk.ComboBoxText()
		for mazhab in mazaheb:
			self.mazahebmenu.append(mazhab, mazhab)
		self.mazahebmenu.set_active(mazaheb.index(defaultmazhab))
		table.attach(mazhablabel, 0, 1, 1, 2, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		table.attach(self.mazahebmenu, 1, 2, 1, 2, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		#Clock Format
		hbox5 = Gtk.Box()
		defaultcf = self.options['hourfmt']
		clockformats = self.handler.GetClockFormats()
		cflabel = Gtk.Label('Clock Format')
		self.cfmenu = Gtk.ComboBoxText()
		for cf in clockformats:
			self.cfmenu.append(cf, cf)
		self.cfmenu.set_active(clockformats.index(defaultcf))
		table.attach(cflabel, 0, 1, 2, 3, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		table.attach(self.cfmenu, 1, 2, 2, 3, Gtk.AttachOptions.EXPAND, Gtk.AttachOptions.EXPAND, 10 ,10)
		tab2child = table
		#Notebook
		notebook.append_page(tab1child, tab1label)
		notebook.append_page(tab2child, tab2label)
		notebook.show_all()
		#Exit, Save Buttons
		buttons = Gtk.Box()
		spacer = Gtk.Box()
		cancel = Gtk.Button.new_from_stock(Gtk.STOCK_CANCEL)
		cancel.connect('clicked', self.destroy_window)
		self.okbutton = Gtk.Button.new_from_stock(Gtk.STOCK_OK)
		self.okbutton.connect('clicked', self.on_click_ok)
		buttons.pack_start(spacer, True, True, 5)
		buttons.pack_start(cancel, False, True, 5)
		buttons.pack_start(self.okbutton, False, True, 5)
		mainbox.pack_start(notebook, True, True, 5)
		mainbox.pack_start(buttons, False, True, 5)
		mainbox.show_all()
		self.add(mainbox)
	
	def GetOptions(self):
		options = []
		options = self.handler.GetOptions()
		return options
		
	def on_click_ok(self, data):
		methods = self.handler.GetCalMethods()
		mazaheb = self.handler.GetMazaheb()
		clockformats = self.handler.GetClockFormats()
		####
		self.options['city'] = self.cityentry.get_text()
		self.options['cal_method_name'] = methods[self.methodsmenu.get_active()]
		self.options['mazhab_name'] = mazaheb[self.mazahebmenu.get_active()]
		self.options['hourfmt'] = clockformats[self.cfmenu.get_active()]
		self.options['city_lat'] = self.latentry.get_text()
		self.options['city_lon'] = self.longentry.get_text()
		print self.options
		self.handler.SaveOptions(self.options)
		self.hide()
	
	def on_click_fetch(self, data):
		entry=self.cityentry.get_text()
		print entry
		url='http://maps.googleapis.com/maps/api/geocode/json?address=%s&sensor=false' % entry
		data = json.loads(urllib.urlopen(url).read())
		if data["status"] == "ZERO_RESULTS":
			self.cityentry.set_text("Error: No results")
			self.okbutton.set_sensitive(False)
		else:
			self.okbutton.set_sensitive(True)
			self.cityentry.set_text('%s' % data["results"][0]['formatted_address'])
			self.latentry.set_text('%s' % data["results"][0]['geometry']['location']['lat'])
			self.longentry.set_text('%s' % data["results"][0]['geometry']['location']['lng'])

	def destroy_window(self, data):
		self.hide()
